Index: /palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- /palm/trunk/SOURCE/advec_ws.f90	(revision 1352)
+++ /palm/trunk/SOURCE/advec_ws.f90	(revision 1353)
@@ -5207,14 +5213,14 @@
                 v_comp    = v(k+1,j+1,i) + v(k,j+1,i) - gv
                 flux_n    = v_comp * (                                       &
-                          ( 37.0 * ibit32 * adv_mom_5                        &
-                       +     7.0 * ibit31 * adv_mom_3                        &
-                       +           ibit30 * adv_mom_1                        &
-                          ) *                                                &
+                          ( 37.0_wp * ibit32 * adv_mom_5                        &
+                       +     7.0_wp * ibit31 * adv_mom_3                        &
+                       +              ibit30 * adv_mom_1                        &
+                          ) *                                                 &
                                  ( w(k,j+1,i) + w(k,j,i)   )                 &
-                   -      (  8.0 * ibit32 * adv_mom_5                        &
-                       +           ibit31 * adv_mom_3                        &
+                   -      (  8.0_wp * ibit32 * adv_mom_5                        &
+                       +              ibit31 * adv_mom_3                        &
                           ) *                                                &
                                  ( w(k,j+2,i) + w(k,j-1,i) )                 &
-                   +      (        ibit32 * adv_mom_5                        &
+                   +      (           ibit32 * adv_mom_5                        &
                           ) *                                                &
                                  ( w(k,j+3,i) + w(k,j-2,i) )                 &
@@ -5222,14 +5228,14 @@
 
                 diss_n    = - ABS( v_comp ) * (                              &
-                          ( 10.0 * ibit32 * adv_mom_5                        &
-                       +     3.0 * ibit31 * adv_mom_3                        &
-                       +           ibit30 * adv_mom_1                        &
+                          ( 10.0_wp * ibit32 * adv_mom_5                        &
+                       +     3.0_wp * ibit31 * adv_mom_3                        &
+                       +              ibit30 * adv_mom_1                        &
                           ) *                                                &
                                  ( w(k,j+1,i) - w(k,j,i)  )                  &
-                   -      (  5.0 * ibit32 * adv_mom_5                        &
-                       +           ibit31 * adv_mom_3                        &
+                   -      (  5.0_wp * ibit32 * adv_mom_5                        &
+                       +              ibit31 * adv_mom_3                        &
                           ) *                                                &
                                  ( w(k,j+2,i) - w(k,j-1,i) )                 &
-                   +      (        ibit32 * adv_mom_5                        &
+                   +      (           ibit32 * adv_mom_5                        &
                           ) *                                                &
                                  ( w(k,j+3,i) - w(k,j-2,i) )                 &
@@ -5246,14 +5252,14 @@
                 w_comp    = w(k,j,i) + w(k-1,j,i)
                 flux_d    = w_comp  * (                                      &
-                          ( 37.0 * ibit35 * adv_mom_5                        &
-                       +     7.0 * ibit34 * adv_mom_3                        &
-                       +           ibit33 * adv_mom_1                        &
+                          ( 37.0_wp * ibit35 * adv_mom_5                        &
+                       +     7.0_wp * ibit34 * adv_mom_3                        &
+                       +              ibit33 * adv_mom_1                        &
                           ) *                                                &
                              ( w(k,j,i)    + w(k-1,j,i)   )                  &
-                   -      (  8.0 * ibit35 * adv_mom_5                        &
-                       +           ibit34 * adv_mom_3                        &
+                   -      (  8.0_wp * ibit35 * adv_mom_5                        &
+                       +              ibit34 * adv_mom_3                        &
                           ) *                                                &
                              ( w(k+1,j,i)  + w(k_mm,j,i)  )                  &
-                   +      (        ibit35 * adv_mom_5                        &
+                   +      (           ibit35 * adv_mom_5                        &
                           ) *                                                &
                              ( w(k_pp,j,i) + w(k_mmm,j,i) )                  &
@@ -5261,14 +5267,14 @@
 
                 diss_d    = - ABS( w_comp ) * (                              &
-                          ( 10.0 * ibit35 * adv_mom_5                        &
-                       +     3.0 * ibit34 * adv_mom_3                        &
-                       +           ibit33 * adv_mom_1                        &
+                          ( 10.0_wp * ibit35 * adv_mom_5                        &
+                       +     3.0_wp * ibit34 * adv_mom_3                        &
+                       +              ibit33 * adv_mom_1                        &
                           ) *                                                &
                              ( w(k,j,i)    - w(k-1,j,i)   )                  &
-                   -      (  5.0 * ibit35 * adv_mom_5                        &
-                       +           ibit34 * adv_mom_3                        &
+                   -      (  5.0_wp * ibit35 * adv_mom_5                        &
+                       +              ibit34 * adv_mom_3                        &
                           ) *                                                &
                              ( w(k+1,j,i)  - w(k_mm,j,i)  )                  &
-                   +      (        ibit35 * adv_mom_5                        &
+                   +      (           ibit35 * adv_mom_5                        &
                           ) *                                                &
                              ( w(k_pp,j,i) - w(k_mmm,j,i) )                  &
@@ -5288,14 +5294,14 @@
                 w_comp    = w(k+1,j,i) + w(k,j,i)
                 flux_t    = w_comp  * (                                      &
-                          ( 37.0 * ibit35 * adv_mom_5                        &
-                       +     7.0 * ibit34 * adv_mom_3                        &
-                       +           ibit33 * adv_mom_1                        &
+                          ( 37.0_wp * ibit35 * adv_mom_5                        &
+                       +     7.0_wp * ibit34 * adv_mom_3                        &
+                       +              ibit33 * adv_mom_1                        &
                           ) *                                                &
                              ( w(k+1,j,i)  + w(k,j,i)     )                  &
-                   -      (  8.0 * ibit35 * adv_mom_5                        &
-                       +           ibit34 * adv_mom_3                        &
+                   -      (  8.0_wp * ibit35 * adv_mom_5                        &
+                       +              ibit34 * adv_mom_3                        &
                           ) *                                                &
                              ( w(k_pp,j,i)  + w(k-1,j,i)  )                  &
-                   +      (        ibit35 * adv_mom_5                        &
+                   +      (           ibit35 * adv_mom_5                        &
                           ) *                                                &
                              ( w(k_ppp,j,i) + w(k_mm,j,i) )                  &
@@ -5303,14 +5309,14 @@
 
                 diss_t    = - ABS( w_comp ) * (                              &
-                          ( 10.0 * ibit35 * adv_mom_5                        &
-                       +     3.0 * ibit34 * adv_mom_3                        &
-                       +           ibit33 * adv_mom_1                        &
+                          ( 10.0_wp * ibit35 * adv_mom_5                        &
+                       +     3.0_wp * ibit34 * adv_mom_3                        &
+                       +              ibit33 * adv_mom_1                        &
                           ) *                                                &
                              ( w(k+1,j,i)   - w(k,j,i)    )                  &
-                   -      (  5.0 * ibit35 * adv_mom_5                        &
-                       +           ibit34 * adv_mom_3                        &
+                   -      (  5.0_wp * ibit35 * adv_mom_5                        &
+                       +              ibit34 * adv_mom_3                        &
                           ) *                                                &
                              ( w(k_pp,j,i)  - w(k-1,j,i)  )                  &
-                   +      (        ibit35 * adv_mom_5                        &
+                   +      (           ibit35 * adv_mom_5                        &
                           ) *                                                &
                              ( w(k_ppp,j,i) - w(k_mm,j,i) )                  &
@@ -5324,5 +5330,5 @@
                     +   ( w_comp      - ( w(k,j,i)   + w(k-1,j,i) ) )        &
                                                                  * ddzu(k+1) &
-                      ) * 0.5
+                      ) * 0.5_wp 
 
                 tend(k,j,i) = - (                                                &
Index: /palm/trunk/SOURCE/boundary_conds.f90
===================================================================
--- /palm/trunk/SOURCE/boundary_conds.f90	(revision 1352)
+++ /palm/trunk/SOURCE/boundary_conds.f90	(revision 1353)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-!
+! REAL constants provided with KIND-attribute
 !  
 ! Former revisions:
@@ -139,5 +139,5 @@
     DO  i = nxlg, nxrg
        DO  j = nysg, nyng
-          w_p(nzb_w_inner(j,i),j,i) = 0.0
+          w_p(nzb_w_inner(j,i),j,i) = 0.0_wp
        ENDDO
     ENDDO
@@ -162,5 +162,5 @@
     ENDIF
     !$acc kernels present( w_p )
-    w_p(nzt:nzt+1,:,:) = 0.0  ! nzt is not a prognostic level (but cf. pres)
+    w_p(nzt:nzt+1,:,:) = 0.0_wp  ! nzt is not a prognostic level (but cf. pres)
     !$acc end kernels
 
@@ -366,11 +366,11 @@
           c_max = dy / dt_3d
 
-          c_u_m_l = 0.0 
-          c_v_m_l = 0.0
-          c_w_m_l = 0.0
-
-          c_u_m = 0.0 
-          c_v_m = 0.0
-          c_w_m = 0.0
+          c_u_m_l = 0.0_wp 
+          c_v_m_l = 0.0_wp
+          c_w_m_l = 0.0_wp
+
+          c_u_m = 0.0_wp 
+          c_v_m = 0.0_wp
+          c_w_m = 0.0_wp
 
 !
@@ -382,8 +382,8 @@
                 denom = u_m_s(k,0,i) - u_m_s(k,1,i)
 
-                IF ( denom /= 0.0 )  THEN
+                IF ( denom /= 0.0_wp )  THEN
                    c_u(k,i) = -c_max * ( u(k,0,i) - u_m_s(k,0,i) ) / ( denom * tsc(2) )
-                   IF ( c_u(k,i) < 0.0 )  THEN
-                      c_u(k,i) = 0.0
+                   IF ( c_u(k,i) < 0.0_wp )  THEN
+                      c_u(k,i) = 0.0_wp
                    ELSEIF ( c_u(k,i) > c_max )  THEN
                       c_u(k,i) = c_max
@@ -395,8 +395,8 @@
                 denom = v_m_s(k,1,i) - v_m_s(k,2,i)
 
-                IF ( denom /= 0.0 )  THEN
+                IF ( denom /= 0.0_wp )  THEN
                    c_v(k,i) = -c_max * ( v(k,1,i) - v_m_s(k,1,i) ) / ( denom * tsc(2) )
-                   IF ( c_v(k,i) < 0.0 )  THEN
-                      c_v(k,i) = 0.0
+                   IF ( c_v(k,i) < 0.0_wp )  THEN
+                      c_v(k,i) = 0.0_wp
                    ELSEIF ( c_v(k,i) > c_max )  THEN
                       c_v(k,i) = c_max
@@ -408,8 +408,8 @@
                 denom = w_m_s(k,0,i) - w_m_s(k,1,i)
 
-                IF ( denom /= 0.0 )  THEN
+                IF ( denom /= 0.0_wp )  THEN
                    c_w(k,i) = -c_max * ( w(k,0,i) - w_m_s(k,0,i) ) / ( denom * tsc(2) )
-                   IF ( c_w(k,i) < 0.0 )  THEN
-                      c_w(k,i) = 0.0
+                   IF ( c_w(k,i) < 0.0_wp )  THEN
+                      c_w(k,i) = 0.0_wp
                    ELSEIF ( c_w(k,i) > c_max )  THEN
                       c_w(k,i) = c_max
@@ -472,11 +472,11 @@
 !--       Bottom boundary at the outflow
           IF ( ibc_uv_b == 0 )  THEN
-             u_p(nzb,-1,:) = 0.0 
-             v_p(nzb,0,:)  = 0.0  
+             u_p(nzb,-1,:) = 0.0_wp 
+             v_p(nzb,0,:)  = 0.0_wp  
           ELSE                    
              u_p(nzb,-1,:) =  u_p(nzb+1,-1,:)
              v_p(nzb,0,:)  =  v_p(nzb+1,0,:)
           ENDIF
-          w_p(nzb,-1,:) = 0.0
+          w_p(nzb,-1,:) = 0.0_wp
 
 !
@@ -489,5 +489,5 @@
              v_p(nzt+1,0,:)  = v(nzt,0,:)
           ENDIF
-          w_p(nzt:nzt+1,-1,:) = 0.0
+          w_p(nzt:nzt+1,-1,:) = 0.0_wp
 
        ENDIF
@@ -505,11 +505,11 @@
           c_max = dy / dt_3d
 
-          c_u_m_l = 0.0 
-          c_v_m_l = 0.0
-          c_w_m_l = 0.0
-
-          c_u_m = 0.0 
-          c_v_m = 0.0
-          c_w_m = 0.0
+          c_u_m_l = 0.0_wp 
+          c_v_m_l = 0.0_wp
+          c_w_m_l = 0.0_wp
+
+          c_u_m = 0.0_wp 
+          c_v_m = 0.0_wp
+          c_w_m = 0.0_wp
 
 !
@@ -521,8 +521,8 @@
                 denom = u_m_n(k,ny,i) - u_m_n(k,ny-1,i)
 
-                IF ( denom /= 0.0 )  THEN
+                IF ( denom /= 0.0_wp )  THEN
                    c_u(k,i) = -c_max * ( u(k,ny,i) - u_m_n(k,ny,i) ) / ( denom * tsc(2) )
-                   IF ( c_u(k,i) < 0.0 )  THEN
-                      c_u(k,i) = 0.0
+                   IF ( c_u(k,i) < 0.0_wp )  THEN
+                      c_u(k,i) = 0.0_wp
                    ELSEIF ( c_u(k,i) > c_max )  THEN
                       c_u(k,i) = c_max
@@ -534,8 +534,8 @@
                 denom = v_m_n(k,ny,i) - v_m_n(k,ny-1,i)
 
-                IF ( denom /= 0.0 )  THEN
+                IF ( denom /= 0.0_wp )  THEN
                    c_v(k,i) = -c_max * ( v(k,ny,i) - v_m_n(k,ny,i) ) / ( denom * tsc(2) )
-                   IF ( c_v(k,i) < 0.0 )  THEN
-                      c_v(k,i) = 0.0
+                   IF ( c_v(k,i) < 0.0_wp )  THEN
+                      c_v(k,i) = 0.0_wp
                    ELSEIF ( c_v(k,i) > c_max )  THEN
                       c_v(k,i) = c_max
@@ -547,8 +547,8 @@
                 denom = w_m_n(k,ny,i) - w_m_n(k,ny-1,i)
 
-                IF ( denom /= 0.0 )  THEN
+                IF ( denom /= 0.0_wp )  THEN
                    c_w(k,i) = -c_max * ( w(k,ny,i) - w_m_n(k,ny,i) ) / ( denom * tsc(2) )
-                   IF ( c_w(k,i) < 0.0 )  THEN
-                      c_w(k,i) = 0.0
+                   IF ( c_w(k,i) < 0.0_wp )  THEN
+                      c_w(k,i) = 0.0_wp
                    ELSEIF ( c_w(k,i) > c_max )  THEN
                       c_w(k,i) = c_max
@@ -611,11 +611,11 @@
 !--       Bottom boundary at the outflow
           IF ( ibc_uv_b == 0 )  THEN
-             u_p(nzb,ny+1,:) = 0.0 
-             v_p(nzb,ny+1,:) = 0.0   
+             u_p(nzb,ny+1,:) = 0.0_wp
+             v_p(nzb,ny+1,:) = 0.0_wp   
           ELSE                    
              u_p(nzb,ny+1,:) =  u_p(nzb+1,ny+1,:)
              v_p(nzb,ny+1,:) =  v_p(nzb+1,ny+1,:)
           ENDIF
-          w_p(nzb,ny+1,:) = 0.0
+          w_p(nzb,ny+1,:) = 0.0_wp
 
 !
@@ -628,5 +628,5 @@
              v_p(nzt+1,ny+1,:) = v_p(nzt,nyn+1,:)
           ENDIF
-          w_p(nzt:nzt+1,ny+1,:) = 0.0
+          w_p(nzt:nzt+1,ny+1,:) = 0.0_wp
 
        ENDIF
@@ -644,11 +644,11 @@
           c_max = dx / dt_3d
 
-          c_u_m_l = 0.0 
-          c_v_m_l = 0.0
-          c_w_m_l = 0.0
-
-          c_u_m = 0.0 
-          c_v_m = 0.0
-          c_w_m = 0.0
+          c_u_m_l = 0.0_wp 
+          c_v_m_l = 0.0_wp
+          c_w_m_l = 0.0_wp
+
+          c_u_m = 0.0_wp 
+          c_v_m = 0.0_wp
+          c_w_m = 0.0_wp
 
 !
@@ -660,8 +660,8 @@
                 denom = u_m_l(k,j,1) - u_m_l(k,j,2)
 
-                IF ( denom /= 0.0 )  THEN
+                IF ( denom /= 0.0_wp )  THEN
                    c_u(k,j) = -c_max * ( u(k,j,1) - u_m_l(k,j,1) ) / ( denom * tsc(2) )
-                   IF ( c_u(k,j) < 0.0 )  THEN
-                      c_u(k,j) = 0.0
+                   IF ( c_u(k,j) < 0.0_wp )  THEN
+                      c_u(k,j) = 0.0_wp
                    ELSEIF ( c_u(k,j) > c_max )  THEN
                       c_u(k,j) = c_max
@@ -673,8 +673,8 @@
                 denom = v_m_l(k,j,0) - v_m_l(k,j,1)
 
-                IF ( denom /= 0.0 )  THEN
+                IF ( denom /= 0.0_wp )  THEN
                    c_v(k,j) = -c_max * ( v(k,j,0) - v_m_l(k,j,0) ) / ( denom * tsc(2) )
-                   IF ( c_v(k,j) < 0.0 )  THEN
-                      c_v(k,j) = 0.0
+                   IF ( c_v(k,j) < 0.0_wp )  THEN
+                      c_v(k,j) = 0.0_wp
                    ELSEIF ( c_v(k,j) > c_max )  THEN
                       c_v(k,j) = c_max
@@ -686,8 +686,8 @@
                 denom = w_m_l(k,j,0) - w_m_l(k,j,1)
 
-                IF ( denom /= 0.0 )  THEN
+                IF ( denom /= 0.0_wp )  THEN
                    c_w(k,j) = -c_max * ( w(k,j,0) - w_m_l(k,j,0) ) / ( denom * tsc(2) )
-                   IF ( c_w(k,j) < 0.0 )  THEN
-                      c_w(k,j) = 0.0
+                   IF ( c_w(k,j) < 0.0_wp )  THEN
+                      c_w(k,j) = 0.0_wp
                    ELSEIF ( c_w(k,j) > c_max )  THEN
                       c_w(k,j) = c_max
@@ -750,11 +750,11 @@
 !--       Bottom boundary at the outflow
           IF ( ibc_uv_b == 0 )  THEN
-             u_p(nzb,:,0)  = 0.0 
-             v_p(nzb,:,-1) = 0.0
+             u_p(nzb,:,0)  = 0.0_wp 
+             v_p(nzb,:,-1) = 0.0_wp
           ELSE                    
              u_p(nzb,:,0)  =  u_p(nzb+1,:,0)
              v_p(nzb,:,-1) =  v_p(nzb+1,:,-1)
           ENDIF
-          w_p(nzb,:,-1) = 0.0
+          w_p(nzb,:,-1) = 0.0_wp
 
 !
@@ -767,5 +767,5 @@
              v_p(nzt+1,:,-1) = v_p(nzt,:,-1)
           ENDIF
-          w_p(nzt:nzt+1,:,-1) = 0.0
+          w_p(nzt:nzt+1,:,-1) = 0.0_wp
 
        ENDIF
@@ -783,11 +783,11 @@
           c_max = dx / dt_3d
 
-          c_u_m_l = 0.0 
-          c_v_m_l = 0.0
-          c_w_m_l = 0.0
-
-          c_u_m = 0.0 
-          c_v_m = 0.0
-          c_w_m = 0.0
+          c_u_m_l = 0.0_wp 
+          c_v_m_l = 0.0_wp
+          c_w_m_l = 0.0_wp
+
+          c_u_m = 0.0_wp 
+          c_v_m = 0.0_wp
+          c_w_m = 0.0_wp
 
 !
@@ -799,8 +799,8 @@
                 denom = u_m_r(k,j,nx) - u_m_r(k,j,nx-1)
 
-                IF ( denom /= 0.0 )  THEN
+                IF ( denom /= 0.0_wp )  THEN
                    c_u(k,j) = -c_max * ( u(k,j,nx) - u_m_r(k,j,nx) ) / ( denom * tsc(2) )
-                   IF ( c_u(k,j) < 0.0 )  THEN
-                      c_u(k,j) = 0.0
+                   IF ( c_u(k,j) < 0.0_wp )  THEN
+                      c_u(k,j) = 0.0_wp
                    ELSEIF ( c_u(k,j) > c_max )  THEN
                       c_u(k,j) = c_max
@@ -812,8 +812,8 @@
                 denom = v_m_r(k,j,nx) - v_m_r(k,j,nx-1)
 
-                IF ( denom /= 0.0 )  THEN
+                IF ( denom /= 0.0_wp )  THEN
                    c_v(k,j) = -c_max * ( v(k,j,nx) - v_m_r(k,j,nx) ) / ( denom * tsc(2) )
-                   IF ( c_v(k,j) < 0.0 )  THEN
-                      c_v(k,j) = 0.0
+                   IF ( c_v(k,j) < 0.0_wp )  THEN
+                      c_v(k,j) = 0.0_wp
                    ELSEIF ( c_v(k,j) > c_max )  THEN
                       c_v(k,j) = c_max
@@ -825,8 +825,8 @@
                 denom = w_m_r(k,j,nx) - w_m_r(k,j,nx-1)
 
-                IF ( denom /= 0.0 )  THEN
+                IF ( denom /= 0.0_wp )  THEN
                    c_w(k,j) = -c_max * ( w(k,j,nx) - w_m_r(k,j,nx) ) / ( denom * tsc(2) )
-                   IF ( c_w(k,j) < 0.0 )  THEN
-                      c_w(k,j) = 0.0
+                   IF ( c_w(k,j) < 0.0_wp )  THEN
+                      c_w(k,j) = 0.0_wp
                    ELSEIF ( c_w(k,j) > c_max )  THEN
                       c_w(k,j) = c_max
@@ -889,11 +889,11 @@
 !--       Bottom boundary at the outflow
           IF ( ibc_uv_b == 0 )  THEN
-             u_p(nzb,:,nx+1) = 0.0
-             v_p(nzb,:,nx+1) = 0.0 
+             u_p(nzb,:,nx+1) = 0.0_wp
+             v_p(nzb,:,nx+1) = 0.0_wp 
           ELSE                    
              u_p(nzb,:,nx+1) =  u_p(nzb+1,:,nx+1)
              v_p(nzb,:,nx+1) =  v_p(nzb+1,:,nx+1)
           ENDIF
-          w_p(nzb,:,nx+1) = 0.0
+          w_p(nzb,:,nx+1) = 0.0_wp
 
 !
@@ -906,5 +906,5 @@
              v_p(nzt+1,:,nx+1) = v_p(nzt,:,nx+1)
           ENDIF
-          w(nzt:nzt+1,:,nx+1) = 0.0
+          w(nzt:nzt+1,:,nx+1) = 0.0_wp
 
        ENDIF
Index: /palm/trunk/SOURCE/buoyancy.f90
===================================================================
--- /palm/trunk/SOURCE/buoyancy.f90	(revision 1352)
+++ /palm/trunk/SOURCE/buoyancy.f90	(revision 1353)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! ------------------
-!
+! REAL constants provided with KIND-attribute
 !
 ! Former revisions:
@@ -133,8 +133,9 @@
              DO  j = nys, nyn
                 DO  k = nzb_s_inner(j,i)+1, nzt-1
-                   tend(k,j,i) = tend(k,j,i) + atmos_ocean_sign * g * 0.5 * (  &
-                          ( var(k,j,i)   - ref_state(k) )   / ref_state(k) +   &
-                          ( var(k+1,j,i) - ref_state(k+1) ) / ref_state(k+1)   &
-                                                                            )
+                   tend(k,j,i) = tend(k,j,i) + atmos_ocean_sign * g * 0.5_wp * &
+                          (                                                    &
+                             ( var(k,j,i)   - ref_state(k) )   / ref_state(k) + &
+                             ( var(k+1,j,i) - ref_state(k+1) ) / ref_state(k+1) &
+                          )
                 ENDDO
              ENDDO
@@ -154,7 +155,7 @@
                    DO  k = nzb_s_inner(j,i)+1, nzt-1
                       tend(k,j,i) = tend(k,j,i) + g * sin_alpha_surface *      &
-                           0.5 * ( ( pt(k,j,i-1)         + pt(k,j,i)         ) &
-                                 - ( pt_slope_ref(k,i-1) + pt_slope_ref(k,i) ) &
-                                 ) / pt_surface
+                           0.5_wp * ( ( pt(k,j,i-1)         + pt(k,j,i)         ) &
+                                    - ( pt_slope_ref(k,i-1) + pt_slope_ref(k,i) ) &
+                                    ) / pt_surface
                    ENDDO
                 ENDDO
@@ -167,7 +168,7 @@
                    DO  k = nzb_s_inner(j,i)+1, nzt-1
                       tend(k,j,i) = tend(k,j,i) + g * cos_alpha_surface *      &
-                           0.5 * ( ( pt(k,j,i)         + pt(k+1,j,i)         ) &
-                                 - ( pt_slope_ref(k,i) + pt_slope_ref(k+1,i) ) &
-                                 ) / pt_surface
+                           0.5_wp * ( ( pt(k,j,i)         + pt(k+1,j,i)         ) &
+                                    - ( pt_slope_ref(k,i) + pt_slope_ref(k+1,i) ) &
+                                    ) / pt_surface
                    ENDDO
                 ENDDO
@@ -231,8 +232,9 @@
                 !$acc loop independent vector
                 DO  k = nzb_s_inner(j,i)+1, nzt-1
-                   tend(k,j,i) = tend(k,j,i) + atmos_ocean_sign * g * 0.5 * (  &
-                          ( var(k,j,i)   - ref_state(k) )   / ref_state(k) +   &
-                          ( var(k+1,j,i) - ref_state(k+1) ) / ref_state(k+1)   &
-                                                                            )
+                   tend(k,j,i) = tend(k,j,i) + atmos_ocean_sign * g * 0.5_wp * &
+                          (                                                    &
+                             ( var(k,j,i)   - ref_state(k) )   / ref_state(k) + &
+                             ( var(k+1,j,i) - ref_state(k+1) ) / ref_state(k+1) &
+                          )
                 ENDDO
              ENDDO
@@ -253,7 +255,7 @@
                    DO  k = nzb_s_inner(j,i)+1, nzt-1
                       tend(k,j,i) = tend(k,j,i) + g * sin_alpha_surface *      &
-                           0.5 * ( ( pt(k,j,i-1)         + pt(k,j,i)         ) &
-                                 - ( pt_slope_ref(k,i-1) + pt_slope_ref(k,i) ) &
-                                 ) / pt_surface
+                           0.5_wp * ( ( pt(k,j,i-1)         + pt(k,j,i)         ) &
+                                    - ( pt_slope_ref(k,i-1) + pt_slope_ref(k,i) ) &
+                                    ) / pt_surface
                    ENDDO
                 ENDDO
@@ -266,7 +268,7 @@
                    DO  k = nzb_s_inner(j,i)+1, nzt-1
                       tend(k,j,i) = tend(k,j,i) + g * cos_alpha_surface *      &
-                           0.5 * ( ( pt(k,j,i)         + pt(k+1,j,i)         ) &
-                                 - ( pt_slope_ref(k,i) + pt_slope_ref(k+1,i) ) &
-                                 ) / pt_surface
+                           0.5_wp * ( ( pt(k,j,i)         + pt(k+1,j,i)         ) &
+                                    - ( pt_slope_ref(k,i) + pt_slope_ref(k+1,i) ) &
+                                    ) / pt_surface
                    ENDDO
                 ENDDO
@@ -328,8 +330,8 @@
 !--       Normal case: horizontal surface
           DO  k = nzb_s_inner(j,i)+1, nzt-1
-              tend(k,j,i) = tend(k,j,i) + atmos_ocean_sign * g * 0.5 * (       &
+              tend(k,j,i) = tend(k,j,i) + atmos_ocean_sign * g * 0.5_wp * (    &
                         ( var(k,j,i)   - ref_state(k)   ) / ref_state(k)   +   &
                         ( var(k+1,j,i) - ref_state(k+1) ) / ref_state(k+1)     &
-                                                                       )
+                                                                          )
           ENDDO
 
@@ -345,7 +347,7 @@
              DO  k = nzb_s_inner(j,i)+1, nzt-1
                 tend(k,j,i) = tend(k,j,i) + g * sin_alpha_surface *            &
-                           0.5 * ( ( pt(k,j,i-1)         + pt(k,j,i)         ) &
-                                 - ( pt_slope_ref(k,i-1) + pt_slope_ref(k,i) ) &
-                                 ) / pt_surface
+                           0.5_wp * ( ( pt(k,j,i-1)         + pt(k,j,i)         ) &
+                                    - ( pt_slope_ref(k,i-1) + pt_slope_ref(k,i) ) &
+                                    ) / pt_surface
              ENDDO
 
@@ -354,7 +356,7 @@
              DO  k = nzb_s_inner(j,i)+1, nzt-1
                 tend(k,j,i) = tend(k,j,i) + g * cos_alpha_surface *            &
-                           0.5 * ( ( pt(k,j,i)         + pt(k+1,j,i)         ) &
-                                 - ( pt_slope_ref(k,i) + pt_slope_ref(k+1,i) ) &
-                                 ) / pt_surface
+                           0.5_wp * ( ( pt(k,j,i)         + pt(k+1,j,i)         ) &
+                                    - ( pt_slope_ref(k,i) + pt_slope_ref(k+1,i) ) &
+                                    ) / pt_surface
              ENDDO
 
@@ -430,5 +432,5 @@
           !$OMP PARALLEL PRIVATE( i, j, k, tn )
 !$        tn = omp_get_thread_num()
-          sums_l(:,pr,tn) = 0.0
+          sums_l(:,pr,tn) = 0.0_wp
           !$OMP DO
           DO  i = nxl, nxr
Index: /palm/trunk/SOURCE/calc_liquid_water_content.f90
===================================================================
--- /palm/trunk/SOURCE/calc_liquid_water_content.f90	(revision 1352)
+++ /palm/trunk/SOURCE/calc_liquid_water_content.f90	(revision 1353)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-!
+! REAL constants provided with KIND-attribute
 !
 ! Former revisions:
@@ -97,44 +97,44 @@
 !
 !--          Compute saturation water vapor pressure at t_l
-             e_s = 610.78 * EXP( 17.269 * ( t_l - 273.16 ) /                   &
-                                          ( t_l - 35.86 ) )
+             e_s = 610.78_wp * EXP( 17.269_wp * ( t_l - 273.16_wp ) /          &
+                                                ( t_l - 35.86_wp ) )
 
 !
 !--          Compute approximation of saturation humidity
-             q_s = 0.622 * e_s / ( hyp(k) - 0.378 * e_s )
+             q_s = 0.622_wp * e_s / ( hyp(k) - 0.378_wp * e_s )
 
 !
 !--          Correction factor
-             alpha = 0.622 * l_d_r * l_d_cp / ( t_l * t_l )
+             alpha = 0.622_wp * l_d_r * l_d_cp / ( t_l * t_l )
 
 !
 !--          Correction of the approximated value
 !--          (see: Cuijpers + Duynkerke, 1993, JAS, 23)
-             q_s = q_s * ( 1.0 + alpha * q(k,j,i) ) / ( 1.0 + alpha * q_s )
+             q_s = q_s * ( 1.0_wp + alpha * q(k,j,i) ) / ( 1.0_wp + alpha * q_s )
 
 !
 !--          Compute the liquid water content
              IF ( icloud_scheme == 0  .AND.  precipitation)  THEN
-                IF ( ( q(k,j,i) - q_s - qr(k,j,i) ) > 0.0 ) THEN
+                IF ( ( q(k,j,i) - q_s - qr(k,j,i) ) > 0.0_wp ) THEN
                    qc(k,j,i) = q(k,j,i) - q_s - qr(k,j,i)
                    ql(k,j,i) = qc(k,j,i) + qr(k,j,i)
                 ELSE
                    IF ( q(k,j,i) < qr(k,j,i) )  q(k,j,i) = qr(k,j,i)
-                   qc(k,j,i) = 0.0 
+                   qc(k,j,i) = 0.0_wp 
                    ql(k,j,i) = qr(k,j,i)
                 ENDIF
              ELSEIF ( icloud_scheme == 0  .AND.  .NOT. precipitation )  THEN
-                IF ( ( q(k,j,i) - q_s ) > 0.0 ) THEN
+                IF ( ( q(k,j,i) - q_s ) > 0.0_wp ) THEN
                    qc(k,j,i) = q(k,j,i) - q_s
                    ql(k,j,i) = qc(k,j,i)
                 ELSE
-                   qc(k,j,i) = 0.0 
-                   ql(k,j,i) = 0.0
+                   qc(k,j,i) = 0.0_wp 
+                   ql(k,j,i) = 0.0_wp
                 ENDIF
              ELSE
-                IF ( ( q(k,j,i) - q_s ) > 0.0 ) THEN
+                IF ( ( q(k,j,i) - q_s ) > 0.0_wp ) THEN
                    ql(k,j,i) = q(k,j,i) - q_s
                 ELSE
-                   ql(k,j,i) = 0.0 
+                   ql(k,j,i) = 0.0_wp 
                 ENDIF
              ENDIF
